#!/usr/bin/perl
#
# ^^ Set The Perl Path Above ^^
#################################
#      Simple Download
#       Version: 3.0 Final
#-------------------------------------------------------
# Please leave this copyright intact
#################################
#    (c) 1999 Simple Scripts
#     - All Rights Reserved -
# http://cgiscripts.ampleworks.com/
#################################

require "configure.dat.pl";

###########################################
# Read the form input or get method

$action = $ENV{'QUERY_STRING'};

if ($action) 
{	
 @pairs = split(/&/, $action);
} else {
 read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
 @pairs = split(/&/, $buffer);
}
foreach $pair (@pairs) 
{
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $name =~ tr/+/ /;
 $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $FORM{$name} = $value;
}

$filequery = $FORM{'file'};

if ($FORM{'setupnow'} eq 'yes') { &savesetup; }
elsif ($FORM{'login'} eq 'now') { &verify; }
elsif ($FORM{'checkstats'}) { &stats; }
elsif ($FORM{'clearstats'}) { &remove; }
elsif ($FORM{'checkver'}) { &checkversion; }
elsif ($FORM{'return'}) { &mainmenu("Done looking at stats"); }
elsif ($FORM{'action'} eq "admin") { &passmenu("Please Login");  }
elsif ($action=~/.+/) { &redirect("$action");  }
else { &redirect("$filequery"); }

sub redirect 
{
 my $getfile = shift;
 
 unless ($downdir) 
 { 
  &setup;
  exit;
 }

 $filenames =  "$downdir/$getfile";

 open (download,"+<$datapath/download.txt") || &removelock;
 flock (download,2); seek (download,0,0);
 @infile = <download>;

 $record = 0;
 $correctspot = 'not';

 while (($correctspot eq 'not') && ($record <= $#infile))  
 { 
  ($count,$filename,$eol) = split(/\|\^\|/,$infile[$record]);
  if ($filename eq $getfile)
  {
   $count++;
   $infile[$record] = join ("\|\^\|",$count,$filename,"\n");
   $correctspot = 'Yes';
  }
  $record++;
 }
 if ($correctspot eq 'not')
 { 
  $count = 1;
  $newrecord = join ("\|\^\|",$count,$getfile,"\n");
  push @infile, $newrecord;
 }

 @outfile = sort {($b =~ /(\d+)/)[0] <=> ($a =~ /(\d+)/)[0]} @infile;

 seek (download,0,0);
 print (download @outfile);
 truncate (download,tell(download));
 close (download);

 print "Location: $filenames\n\n";

 exit;
}

sub passmenu 
{
 my $message = shift;
 print "Content-type: text/html\n\n";
 print qq~ 
 <html>
 <head>
    <title> Simple Download $version >> Login</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">$message
    </font>
</h4> </center> <br>
<font face="arial" size="-1">
 <center><br>Please enter your login information 
 <br>to gain access to the admin menu
 </center><br><center>
 <form method="post" action="download.cgi">
    Username: <input type="text" name="username"><br>
	Password: <input type="password" name="password"><br>
	<input type="hidden" name="login" value="now">
	<input type="submit" value="Login">
 </form></center>
 <br><br>
 <hr>
<center>  <h5><font face="Arial, Helvetica, sans-serif"><i>Simple Download $version </i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5> </center>
 </font>
</body>
</html> ~;
exit;
}

sub verify 
{
 if ($FORM{'password'} eq "") 
 {
  &error("Please enter a password"); 
 }
 elsif ($FORM{'username'} eq "") 
 {
 
 }
 $checkpass = crypt($FORM{'password'}, ak);
 if (($FORM{'username'} eq $username) && ($checkpass eq $password)) 
 {
  &mainmenu("Welcome");
 } else {
  &error("Your login info is incorrect");
 }
 exit;
}

sub mainmenu 
{
 my $status = shift;
 print "Content-type: text/html\n\n";
 print qq~
 <html>
 <head>
    <title> Simple Download $version >> Admin Menu</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">$status
    </font>
</h4> </center> <br><br>
<font face="arial" size="-1">
  <table border="0" align="center">
    <tr> 
      <td width="167" align="center" valign="top">
        <form action="download.cgi" method="post">
		<font face="arial" size="-1">
		Click Here to check your download stats<br>
        <input type="submit" name="checkstats" value="Check Download Stats">
		<br>
		</font>
      </td>
    </tr>
    <tr> 
      <td width="167" align="center" valign="top"> 
	  <font face="arial" size="-1">
	  Click here to delete the download stats<br>
        <input type="submit" name="clearstats" value="Clear Download Stats">
		<br></font>
      </td>
    </tr>
    <tr> 
      <td width="167" align="center" valign="top">
	  <font face="arial" size="-1">
	  Click here to check if there is a new script version 
	  <br>
        <input type="submit" name="checkver" value="CheckForNewScript">
		</font>
       </form>
      </td>
    </tr>
  </table>
 <br><br><br>
<hr>
 <center> <h5><font face="Arial, Helvetica, sans-serif"><i>Simple Download $version</i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5> </center>
	</font>
	</body>
</html> ~;
 exit;
}

sub stats 
{
print "Content-type: text/html\n\n";
 print qq~<html>
 <head>
    <title> Simple Download $version >> Download Stats</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">Download Stats
    </font>
</h4> </center> <br><br>
<font face="arial" size="-1"> ~;

 open data, "<$datapath/download.txt" || &error("I can't read download.txt");
 flock data,2;
 @downloads = <data>;
 close (data);

 $downs = 0;

 foreach $line (@downloads) 
 {
  $downs++;
  ($filescount, $filedown) = split (/\|\^\|/, $line);
  if ($downs > 1) 
  {
   print "<hr><br>\n";
  }
  print "Downloads:&nbsp; <font color=\"blue\"><b>$filescount</b></font><br>\n";
  print "File Name:&nbsp; <b>$filedown</b><br>\n";
 }
 print qq~<br><br>
 <hr>
 <center><form method="post" action="download.cgi">
 <input type="submit" name="return" value="Returnto AdminMenu">
 </form></center><br>
<hr>
 <center> <h5><font face="Arial, Helvetica, sans-serif"><i>Simple Download $version</i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5> </center>
	</font>
	</body>
</html> ~;
exit;
}

sub checkversion 
{
 print "Content-type: text/html\n\n";
 print qq~
 <html>
 <head>
    <title> Simple Download $version >> Check For New Version</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">Version Check
    </font>
</h4> </center> <br><br>
<font face="arial" size="-1"> 
<script language="javascript1.1" src="http://cgiscripts.ampleworks.com/news/sdownload.js">
</script>
<hr>
 <center><form method="post" action="download.cgi">
 <input type="submit" name="return" value="Returnto AdminMenu">
 </form></center><br>
<hr>
 <center> <h5><font face="Arial, Helvetica, sans-serif"><i>Simple Download $version</i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5> </center>
	</font>
	</body>
</html> ~;
exit;
}


sub remove 
{
 unlink ("$datapath/download.txt");
 
 open newlog, ">>$datapath/download.txt" || &error("I can't make download.txt");
 print newlog "";
 close (newlog);

 chmod (0666, "$datapath/download.txt");

 &mainmenu("Done cleaning up the log file");
}


sub setup 
{
 print "Content-type: text/html\n\n";

 print qq~ 
 <html>
 <head>
    <title> Simple Download $version >> First Time Setup</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">First Time Setup
    </font>
</h4> </center> <br><font face="arial" size="-1" color="darkslateblue">
Hello and welcome to the Simple Download $version setup,
We are glad you are using the Simple Download script. I hope you enjoy this script
for many and many years. If you have any comments, please send any comments 
to <a href="kevin\@ampleworks.com">
kevin\@ampleworks.com</a>. Thank You! - Kevin Deliz</font><br>
<font face="arial" size="-1" color="darkslateblue">
 <br>
 <table border="0" width="100%" align="left">
 <tr><td align="left"><font face="arial" size="-1">
   <form method="post" action="download.cgi">
     Enter your desired username and password:<br>
     Username: <input type="text" name="user"><br>
     Password: <input type="password" name="pass"><br>
	 <br>Enter the data path that it is possible 
	 <br>to create the files and read them:<br>
     Data Path: <input type="text" name="path"><br>
	 <br>Enter the URL to this cgi scripts:<br>
     Url to cgi: <input type="text" name="url"><br>
	 <br>Enter the directory that contains all the downloads (files):<br>
	 Download Directory <input type="text" name="ddir"><br>
	 <br>Enter your sites name:<br>
	 Sites Name: <input type="text" name="sitename"><br>
     <input type="hidden" name="setupnow" value="yes">
     <input type="submit" value="SaveSettings">
   </form></font> <br><br>
   <hr>
<center><h5><font face="Arial, Helvetica, sans-serif"><i>Simple Download $version</i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5></center></td></tr></table>
 
</font>
</body>
</html> ~;
exit;
}

sub savesetup 
{
 if ($FORM{'user'} eq "") 
 {
  &error("Please enter your username");
 }
 elsif ($FORM{'pass'} eq "") 
 {
  &error("Please enter your password");
 }
 elsif ($FORM{'path'} eq "") 
 {
  &error("Please enter a data path");
 }
 elsif ($FORM{'url'} eq "") 
 {
  &error("Please enter a url to the cgi");
 }
 unless ($FORM{'url'} =~/http:\/\/.+/) 
 {
  &error("Please enter the url correctly");
 }
 elsif ($FORM{'ddir'} eq "") 
 {
  &error("Please enter a download directory");
 }
 
 $testpath = $FORM{'path'};

 if (-e "$testpath/configure.dat.pl") 
 {
  $copyheader = qq!# No Perl Path Needed
# ^ Set the perl path ^
#
#################################
#    (c) 1999 Simple Scripts
#      All Rights Reserved
# http://cgiscripts.ampleworks.com/
################################# 

#################################
# Edit this file if needed 
!;
  $encrypt = crypt($FORM{'pass'}, ak);

  $setupdata[0] = "\$username = \"$FORM{'user'}\"\;";
  $setupdata[1] = "\$password = \"$encrypt\"\; ";
  $setupdata[2] = "\$datapath = \"$FORM{'path'}\"\;";
  $setupdata[3] = "\$urlcgi = \"$FORM{'url'}\"\;";
  $setupdata[4] = "\$sitename = \"$FORM{'sitename'}\"\;";
  $setupdata[5] = "\$downdir = \"$FORM{'ddir'}\"\;";
  $setuprint = join ("\n", @setupdata);
  
  open config, ">$testpath/configure.dat.pl" || &error("I can't open the config file");
  print config "$copyheader\n";
  print config "\$version = \"3.0\"\;\n";
  print config "$setuprint\n\n";
  print config "1\;";
  close (config);

  open logfile, ">>$testpath/download.txt" || &error("I can't make download.txt");
  print logfile "";
  close (logfile);

  chmod (0777, "$testpath/download.txt");

  &passmenu("Done configuring, please login");
 }
exit;
}

sub error 
{
 my $error = shift;
 if ($error) 
 {
  print "Content-type: text/html\n\n";
  print qq~  
 <html>
 
 <head>
    <title> Simple Download $version >> $error</title>
 </head>
<body bgcolor="#FFFFFF">
 <br><center>
 <h1>
    <font face="Arial, Helvetica, sans-serif" color="darkslateblue">
    SimpleDownload $version </font>
 </h1>
 <h3>
    <font face="Arial, Helvetica, sans-serif" color="#0000FF"> Admin Area </font>
 </h3>
 <h4>
    <font face="Arial, Helvetica, sans-serif" color="#FF0000">Error
    </font>
</h4> </center> <br><br>
<font face="arial" size="-1" color="red">
 <br>
 Error: $error
  </font>
  <br><br><br>
  <hr>
 <center> <h5><font face="Arial, Helvetica, sans-serif"><i>SimpleDownload $version</i><br>
    Created by: <a href="http://cgiscripts.ampleworks.com/" target="_blank">Simple Scripts.</a> 
    </font></h5></center>
 </body>

</html> ~;
 }
exit;
}

sub removelock {
exit;
}
